﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr160_1
{
    // Интерфейс: 
    interface MyInterface {
        // Объявление метода: 
        char getChar(int n);
        // Объявление индексатора: 
        char this[int k] { 
            get;
        }
    }

    // Первый класс, реализующий интерфейс: 
    class Alpha: MyInterface {
        // Закрытое символьное поле: 
        private char symb;
        // Конструктор с символьньм аргументом: 
        public Alpha(char s) {
            // Полю присваивается значение: 
            symb = s;
        }
        // Описание метода: 
        public char getChar(int n) {
            // Результат: 
            return (char)(symb + n);
        }
        // Описание индексатора: 
        public char this[int k] {
            // Аксессор для считывания значения: 
            get {
                // Результат: 
                return getChar(k);
            }
        }
    }

    // Второй класс, реализующий интерфейс: 
    class Bravo: MyInterface {
        // Закрытое текстовое поле: 
        private string text;
        // Конструктор с текстовым аргументом: 
        public Bravo(string t) {
            // Полю присваивается значение: 
            text = t;
        }
        // Описание метода: 
        public char getChar(int k) { 
            return text[k % text.Length];
        }
        // Описание индексатора: 
        public char this[int k] {
            // Аксессор для считывания значения: 
            get {
                // Результат: 
                return getChar(k);
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Целочисленная переменная: 
            int m = 5;
            // Интерфейсная переменная:
            MyInterface R;
            // Создается объект класса Alpha и ссылка на него 
            // записывается в интерфейсную переменную:
            R = new Alpha('F');
            // Вызов метода через интерфейсную переменную:
            Console.WriteLine("Символы от \'{0}\' до \'{1}\':", R.getChar(-m), R.getChar(m)); 
            // Индексирование объекта через 
            // интерфейсную переменную: 
            for(int i = -m; i <= m; i++) {
                Console.Write("|" + R[i]);
            }
            Console.WriteLine("|");
            // Создается объект класса Bravo и ссылка на него 
            // записывается в интерфейсную переменную:
            R = new Bravo("bravo");
            // Вызов метода через интерфейсную переменную:
            Console.WriteLine("Символы от \'{0}\' до \'{1}\':", R.getChar(0), R.getChar(2 * m + 1)); 
            // Индексирование объекта через 
            // интерфейсную переменную: 
            for(int i = 0; i <= 2 * m + 1; i++) {
                Console.Write("|" + R[i]);
            }
            Console.WriteLine("|");
            // Задержка:
            Console.ReadLine();
        }
    }
}
